Bug 1649574 - Review Request: jaf - JavaBeans Activation Framework
Summary: Review Request: jaf - JavaBeans Activation Framework
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Jie Kang
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/eclipse-ee4j/jaf
Whiteboard:
Depends On: 1649570
Blocks: 1649552
TreeView+ depends on / blocked
 
Reported: 2018-11-13 22:04 UTC by Salman Siddiqui
Modified: 2018-11-26 14:56 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-11-26 14:56:54 UTC
jkang: fedora-review+


Attachments (Terms of Use)
rpmlint - SPEC (58 bytes, text/plain)
2018-11-13 22:06 UTC, Salman Siddiqui
no flags Details
rpmlint - SRPM (95 bytes, text/plain)
2018-11-13 22:06 UTC, Salman Siddiqui
no flags Details
rpmlint - RPM (98 bytes, text/plain)
2018-11-13 22:07 UTC, Salman Siddiqui
no flags Details

Description Salman Siddiqui 2018-11-13 22:04:14 UTC
Spec URL: https://pagure.io/jmc-rpm/blob/master/f/jaf/jaf.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/sasiddiq/jmc/fedora-29-x86_64/00823523-jaf/jaf-1.2.1-1.fc29.src.rpm

Description: Just submitted my first package. I am seeking a sponsor.
The JavaBeans Activation Framework (JAF) is a standard extension to the
Java platform that lets you take advantage of standard services to:
determine the type of an arbitrary piece of data; encapsulate access to it;
discover the operations available on it; and instantiate the appropriate
bean to perform the operation(s).

Fedora Account System Username: sasiddiq
Successful Copr Build: https://copr.fedorainfracloud.org/coprs/sasiddiq/jmc/build/823523/

Comment 1 Salman Siddiqui 2018-11-13 22:06:29 UTC
Created attachment 1505460 [details]
rpmlint - SPEC

Comment 2 Salman Siddiqui 2018-11-13 22:06:45 UTC
Created attachment 1505461 [details]
rpmlint - SRPM

Comment 3 Salman Siddiqui 2018-11-13 22:07:01 UTC
Created attachment 1505462 [details]
rpmlint - RPM

Comment 5 Jie Kang 2018-11-20 19:30:43 UTC
The notice file [1] has:

SPDX-License-Identifier: EPL-2.0 OR BSD-3-Clause OR GPL-2.0 WITH Classpath-exception-2.0

I believe the spec should follow this.

[1] https://github.com/eclipse-ee4j/jaf/blob/master/NOTICE.md

Comment 6 Severin Gehwolf 2018-11-21 09:18:08 UTC
(In reply to Jie Kang from comment #5)
> The notice file [1] has:
> 
> SPDX-License-Identifier: EPL-2.0 OR BSD-3-Clause OR GPL-2.0 WITH
> Classpath-exception-2.0
> 
> I believe the spec should follow this.
> 
> [1] https://github.com/eclipse-ee4j/jaf/blob/master/NOTICE.md

We should use license identifiers as listed in this list:
https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#Good_Licenses

Fedora doesn't use SPDX-License-Identifiers. See:
https://lists.pagure.io/archives/list/devel@lists.fedoraproject.org/thread/UEAZMPBRABEL34N2PULWOYSFLBRAPQVR/

Thus, the above would IMO translate to:

EPL-2.0 OR BSD OR GPLv2 with exceptions

Having said that, I'm not sure how to handle software which is available under more than one license. Best to ask fedora-legal what should be used.

Comment 7 Jie Kang 2018-11-21 14:30:40 UTC
Right, sorry I wasn't clear. I didn't mean to suggest copy and pasting the SPDX list, but only following the list with the appropriate names.

Fedora recommendations for multiple licenses are:
https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Multiple_Licensing_Scenarios

Comment 8 Severin Gehwolf 2018-11-21 15:40:59 UTC
(In reply to Jie Kang from comment #7)
> Right, sorry I wasn't clear. I didn't mean to suggest copy and pasting the
> SPDX list, but only following the list with the appropriate names.
> 
> Fedora recommendations for multiple licenses are:
> https://fedoraproject.org/wiki/Packaging:
> LicensingGuidelines#Multiple_Licensing_Scenarios

OK, thanks! Going by this it appears the spec section should probably look something like this:

License: EPL-2.0 and BSD and GPLv2 with exceptions

On the other hand, I've only came across "Eclipse Distribution License v1.0" (a.k.a BSD) in Java source files in jaf. Are there files explicitly referencing something else? If not, it would make sense to add a comment that the license field is the way it is, because the source is made available under multiple licenses.

Comment 9 Severin Gehwolf 2018-11-21 15:42:38 UTC
From the spec:

Source0:	https://github.com/eclipse-ee4j/jaf/archive/initial-contribution.tar.gz

So this looks like it's in the same boat as javamail 1.6.3?
https://src.fedoraproject.org/rpms/javamail/pull-request/1#c-ade4b2ae47637715d01cabb4e746554164cf4c9a-15

Comment 10 Jie Kang 2018-11-21 15:50:16 UTC
Yes looks like it. The review "page" is here: https://projects.eclipse.org/projects/ee4j.jaf/reviews/1.2.1-release-review

The state says "successful" but the GitHub repository doesn't have any tags (yet?). Maybe they put the tarballs somewhere else; I'll try to search.

Comment 11 Jie Kang 2018-11-21 15:53:24 UTC
Actually, I should wait till tomorrow at the least as today is the last day for review. Sorry for the fluff.

Comment 13 Jie Kang 2018-11-23 17:49:12 UTC
The activation-api jar seems to contain a few extra classes compared to a maven build from the repository. It's about 20K bigger.

Comment 15 Jie Kang 2018-11-23 21:31:47 UTC
Note: the provides of the latest rpm are:
jaf:
    jaf
    mvn(com.sun.activation:all:pom:)
    mvn(com.sun.activation:jakarta.activation)
    mvn(com.sun.activation:jakarta.activation:pom:)
    mvn(jakarta.activation:jakarta.activation-api)
    mvn(jakarta.activation:jakarta.activation-api:pom:)
    osgi(com.sun.activation.jakarta.activation)
    osgi(jakarta.activation-api)

The provides of the previous rpm are:
jaf:
    jaf
    mvn(com.sun.activation:all:pom:)
    mvn(com.sun.activation:javax.activation)
    mvn(com.sun.activation:javax.activation:pom:)
    mvn(javax.activation:javax.activation-api)
    mvn(javax.activation:javax.activation-api:pom:)
    osgi(com.sun.activation.javax.activation)
    osgi(javax.activation-api)

The latest upstream release published an entry for com.sun.activation:jakarta.activation to maven central so I guess this is okay. I'm not sure though.

Comment 16 Jie Kang 2018-11-23 22:05:35 UTC
jaf Package Review 1
====================

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "EPL", "Unknown or generated". 56 files have
     unknown license. Detailed output of licensecheck in /home/jkang/Work
     /fedora-reviews/jaf/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in jaf-
     javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: jaf-1.2.1-2.fc28.noarch.rpm
          jaf-javadoc-1.2.1-2.fc28.noarch.rpm
          jaf-1.2.1-2.fc28.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.

Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
jaf.noarch: W: invalid-url URL: https://github.com/eclipse-ee4j/jaf <urlopen error [Errno -2] Name or service not known>
jaf-javadoc.noarch: W: invalid-url URL: https://github.com/eclipse-ee4j/jaf <urlopen error [Errno -2] Name or service not known>
2 packages and 0 specfiles checked; 0 errors, 2 warnings.

Requires
--------
jaf (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools

jaf-javadoc (rpmlib, GLIBC filtered):
    javapackages-tools

Provides
--------
jaf:
    jaf
    mvn(com.sun.activation:all:pom:)
    mvn(com.sun.activation:jakarta.activation)
    mvn(com.sun.activation:jakarta.activation:pom:)
    mvn(jakarta.activation:jakarta.activation-api)
    mvn(jakarta.activation:jakarta.activation-api:pom:)
    osgi(com.sun.activation.jakarta.activation)
    osgi(jakarta.activation-api)

jaf-javadoc:
    jaf-javadoc

Comment 17 Gwyn Ciesla 2018-11-26 14:53:16 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/jaf


Note You need to log in before you can comment on or make changes to this bug.